﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace BlazorApp1net6.Data
{
    public class HardWareDetails
    {
        public HardWareDetails()
        {

        }
        public HardWareDetails(int TaskID, string Name, string AssignedTo, string Note, string Category, DateTime WEO, string SerialNo, string InvoiceNo, DateTime DOP, string Status)
        {
            this.TaskID = TaskID;
            this.Name = Name;
            this.Note = Note;
            this.AssignedTo = AssignedTo;
            this.WEO = WEO;
            this.Category = Category;
            this.SerialNo = SerialNo;
            this.InvoiceNo = InvoiceNo;
            this.DOP = DOP;
            this.Status = Status;
        }
        public static async Task<List<HardWareDetails>> GetAllRecords()
        {
            await Task.Yield();
            List<HardWareDetails> order = new List<HardWareDetails>();
            int code = 1000;
            for (int i = 1; i < 10; i++)
            {
                order.Add(new HardWareDetails(code + 1, "Lenovo Yoga", "John Doe", "Remarks are noted", "Laptop", new DateTime(2018, 05, 15), "CB27932009", "INV-0984", new DateTime(2021, 7, 16), "Assigned"));
                order.Add(new HardWareDetails(code + 2, "Acer Aspire", "David Anto", "Remarks are noted", "Monitor", new DateTime(2018, 04, 04), "CB35728290", "INV-2712", new DateTime(2020, 9, 11), "In-repair"));
                order.Add(new HardWareDetails(code + 3, "Apple MacBook", "Mary Saveley", "Remarks are noted", "Tablet", new DateTime(2018, 11, 30), "CB35628728", "INV-3782", new DateTime(2021, 10, 7), "Pending"));
                order.Add(new HardWareDetails(code + 4, "Lenovo ThinkPad", "Pascale Cartrain", "Remarks are noted", "Others", new DateTime(2018, 10, 22), "CB56209872", "INV-2980", new DateTime(2021, 12, 30), "Ordered"));
                order.Add(new HardWareDetails(code + 5, "Dell Inspiron", "Paul Henriot", "Remarks are noted", "Laptop", new DateTime(2017, 02, 18), "CB56289036", "INV-2763", new DateTime(2021, 12, 3), "Assigned"));
                order.Add(new HardWareDetails(code + 6, "HP Pavilion", "Mary Saveley", "Remarks are noted", "Tablet", new DateTime(2017, 02, 18), "CB56289305", "INV-3456", new DateTime(2021, 12, 3), "Pending"));
                order.Add(new HardWareDetails(code + 7, "Asus ZenBook", "John Doe", "Remarks are noted", "Monitor", new DateTime(2019, 02, 18), "CB25637891", "INV-2878", new DateTime(2021, 12, 3), "In-repair"));
                code += 7;
            }

            return order;
        }

        public int TaskID { get; set; }
        public string Name { get; set; }
        public string Note { get; set; }
        public string AssignedTo { get; set; }
        public DateTime WEO { get; set; }
        public string Category { get; set; }
        public string SerialNo { get; set; }
        public string InvoiceNo { get; set; }
        public DateTime DOP { get; set; }
        public string Status { get; set; }
        public string ShipAddress { get; set; }
    }


    public class POHeader
    {
        public POHeader()
        {

        }
        public POHeader(int POHeaderID, int POHeaderOrderNumber, DateTime POHeaderOrderDate, int POHeaderSupplierID)
        {
            this.POHeaderID = POHeaderID;
            this.POHeaderOrderNumber = POHeaderOrderNumber;
            this.POHeaderOrderDate = POHeaderOrderDate;
            this.POHeaderSupplierID = POHeaderSupplierID;
        }
        public static async Task<List<POHeader>> GetAllRecords()
        {
            await Task.Yield();
            List<POHeader> order = new List<POHeader>();
            int code = 1000;
            for (int i = 1; i < 10; i++)
            {
                order.Add(new POHeader(code + 1, code + 1,  new DateTime(2018, 05, 15), 35728290));
                order.Add(new POHeader(code + 2, code + 2,  new DateTime(2018, 04, 04), 35728290));
                order.Add(new POHeader(code + 3, code + 3,  new DateTime(2018, 11, 30), 35628728));
                order.Add(new POHeader(code + 4, code + 4,  new DateTime(2018, 10, 22), 56209872));
                order.Add(new POHeader(code + 5, code + 5,  new DateTime(2017, 02, 18), 56289036));
                order.Add(new POHeader(code + 6, code + 6,  new DateTime(2017, 02, 18), 56289305));
                order.Add(new POHeader(code + 7, code + 7,  new DateTime(2019, 02, 18), 25637891));
                code += 7;
            }
            order.OrderBy(x => x.POHeaderOrderDate);
            return order;
        }
        public int POHeaderID { get; set; }
        public int POHeaderOrderNumber { get; set; }
        public DateTime POHeaderOrderDate { get; set; }
        public int POHeaderSupplierID { get; set; }
    }

}
